import React, { Component } from 'react';
import PropTypes from 'prop-types';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var TextInput = function (_React$Component) {
  inherits(TextInput, _React$Component);

  function TextInput(props) {
    classCallCheck(this, TextInput);

    var _this = possibleConstructorReturn(this, (TextInput.__proto__ || Object.getPrototypeOf(TextInput)).call(this, props));

    _this.handleAutoComplete = function (value) {
      var onChange = _this.props.onChange;

      _this.setState({ value: value });
      onChange(value);
    };

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;

      var value = e.target.value;
      _this.setState({ value: value });
      if (onChange) {
        onChange(value);
      }
    };

    _this.M = window.M;
    _this.state = {
      uId: 'text-input-' + Math.random(),
      autocomplete: false,
      value: props.value
    };
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleAutoComplete = _this.handleAutoComplete.bind(_this);
    return _this;
  }

  createClass(TextInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          data = _props.data,
          onChange = _props.onChange;
      var uId = this.state.uId;

      var elem = document.getElementById(uId);
      if (data && onChange) {
        this.M.Autocomplete.init(elem, {
          data: data,
          onAutocomplete: this.handleAutoComplete
        });
        this.setState({ autocomplete: true });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          placeholder = _props2.placeholder,
          label = _props2.label;
      var _state = this.state,
          uId = _state.uId,
          autocomplete = _state.autocomplete,
          value = _state.value;

      return React.createElement(
        'div',
        { className: 'input-field' },
        React.createElement('input', { type: 'text', id: uId, className: autocomplete ? 'autocomplete input-field' : 'input-field', placeholder: placeholder, value: value || '', onChange: this.handleChange }),
        label ? React.createElement(
          'label',
          { htmlFor: '#' + uId },
          label
        ) : null
      );
    }
  }]);
  return TextInput;
}(React.Component);

TextInput.propTypes = {
  placeholder: PropTypes.string,
  data: PropTypes.arrayOf(PropTypes.shape({
    name: PropTypes.string.isRequired
  })),
  onChange: PropTypes.func,
  label: PropTypes.string,
  value: PropTypes.string
};

TextInput.defaultProps = {
  placeholder: null,
  data: [],
  onChange: null,
  label: null,
  value: null
};

var Select = function (_Component) {
  inherits(Select, _Component);

  function Select(props) {
    classCallCheck(this, Select);

    var _this = possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.M = window.M;
    _this.state = {
      uId: 'select-' + Math.random()
    };
    return _this;
  }

  createClass(Select, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var uId = this.state.uId;

      var elem = document.getElementById(uId);
      this.M.FormSelect.init(elem, {});
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          placeholder = _props.placeholder,
          data = _props.data,
          _onChange = _props.onChange,
          value = _props.value;
      var uId = this.state.uId;

      return React.createElement(
        'div',
        { className: 'input-field' },
        _onChange ? React.createElement(
          'select',
          { id: uId, onChange: function onChange(e) {
              return _onChange(e.target.value);
            } },
          React.createElement(
            'option',
            { key: 'disabled', value: '', disabled: true, selected: true },
            value || placeholder
          ),
          data.map(function (option) {
            return React.createElement(
              'option',
              { key: option.key, value: option.key },
              option.value
            );
          })
        ) : React.createElement(
          'select',
          { id: uId },
          React.createElement(
            'option',
            { key: 'disabled', value: '', disabled: true, selected: true },
            value || placeholder
          ),
          data.map(function (option) {
            return React.createElement(
              'option',
              { key: option.key, value: option.key },
              option.value
            );
          })
        )
      );
    }
  }]);
  return Select;
}(Component);

Select.propTypes = {
  placeholder: PropTypes.string,
  data: PropTypes.arrayOf(PropTypes.shape({
    name: PropTypes.string.isRequired
  })),
  onChange: PropTypes.func,
  value: PropTypes.string
};

Select.defaultProps = {
  placeholder: 'Select a value',
  data: [],
  onChange: null,
  value: null
};

var Chips = function (_Component) {
  inherits(Chips, _Component);

  function Chips(props) {
    classCallCheck(this, Chips);

    var _this = possibleConstructorReturn(this, (Chips.__proto__ || Object.getPrototypeOf(Chips)).call(this, props));

    _this.handleChips = function (e, chip) {
      var onChange = _this.props.onChange;
      var uId = _this.state.uId;

      var chipInstance = _this.M.Chips.getInstance(document.getElementById(uId));
      if (onChange) {
        onChange(chipInstance.chipsData.map(function (chip) {
          return chip.tag;
        }));
      }
    };

    _this.handleSelect = function (_, chip) {
      var onSelect = _this.props.onSelect;

      if (onSelect) {
        onSelect(chip.firstChild.data);
      }
    };

    _this.completeInput = function (_) {
      var uId = _this.state.uId;

      var chipInstance = _this.M.Chips.getInstance(document.getElementById(uId));
      chipInstance.addChip({
        tag: document.getElementById(uId).getElementsByClassName('input')[0].value
      });
      document.getElementById(uId).getElementsByClassName('input')[0].value = null;
    };

    _this.deletePrevious = function (e) {
      var uId = _this.state.uId;

      var chipInstance = _this.M.Chips.getInstance(document.getElementById(uId));
      if (chipInstance.chipsData.some(function (chip) {
        return chip.tag === e.target.innerText;
      })) {
        if (chipInstance.chipsData[chipInstance.chipsData.length - 1].tag === e.target.innerText) {
          chipInstance.deleteChip(chipInstance.chipsData.length - 2);
        } else {
          chipInstance.deleteChip(chipInstance.chipsData.length - 1);
        }
      }
    };

    _this.M = window.M;
    _this.state = {
      uId: 'chip-' + Math.random()
    };
    _this.handleChips = _this.handleChips.bind(_this);
    _this.handleSelect = _this.handleSelect.bind(_this);
    _this.completeInput = _this.completeInput.bind(_this);
    _this.deletePrevious = _this.deletePrevious.bind(_this);
    return _this;
  }

  createClass(Chips, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          value = _props.value,
          data = _props.data,
          placeholder = _props.placeholder,
          secondaryPlaceholder = _props.secondaryPlaceholder,
          limit = _props.limit,
          minLength = _props.minLength;
      var uId = this.state.uId;

      var elem = document.getElementById(uId);
      this.M.Chips.init(elem, {
        data: value,
        placeholder: placeholder,
        secondaryPlaceholder: secondaryPlaceholder,
        autocompleteOptions: {
          data: data,
          limit: limit,
          minLength: minLength
        },
        onChipAdd: this.handleChips,
        onChipSelect: this.handleSelect,
        onChipDelete: this.handleChips
      });
      var autoComplete = elem.getElementsByClassName('autocomplete-content')[0];
      var input = elem.getElementsByClassName('input')[0];
      input.addEventListener('blur', this.completeInput);
      autoComplete.addEventListener('click', this.deletePrevious);
    }
  }, {
    key: 'render',
    value: function render() {
      var uId = this.state.uId;

      return React.createElement(
        'div',
        { className: 'input-field' },
        React.createElement('div', { id: uId, className: 'chips chips-placeholder chips-initial chips-autocomplete' })
      );
    }
  }]);
  return Chips;
}(Component);

Chips.propTypes = {
  placeholder: PropTypes.string,
  secondaryPlaceholder: PropTypes.string,
  data: PropTypes.object,
  value: PropTypes.arrayOf(PropTypes.shape({
    tag: PropTypes.string
  })),
  limit: PropTypes.number,
  minLength: PropTypes.number,
  onChange: PropTypes.func,
  onSelect: PropTypes.func
};

Chips.defaultProps = {
  placeholder: '',
  secondaryPlaceholder: '',
  data: {},
  value: [],
  limit: Infinity,
  minLength: 1,
  onChange: null,
  onSelect: null
};

var TextArea = function (_React$Component) {
  inherits(TextArea, _React$Component);

  function TextArea(props) {
    classCallCheck(this, TextArea);

    var _this = possibleConstructorReturn(this, (TextArea.__proto__ || Object.getPrototypeOf(TextArea)).call(this, props));

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;

      var value = e.target.value;
      _this.setState({ value: value });
      if (onChange) {
        onChange(value);
      }
    };

    _this.state = {
      uId: 'text-area-' + Math.random(),
      value: props.value
    };
    _this.textArea = React.createRef();
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(TextArea, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          placeholder = _props.placeholder,
          label = _props.label;
      var _state = this.state,
          uId = _state.uId,
          value = _state.value;

      return React.createElement(
        'div',
        { className: 'input-field' },
        React.createElement(
          'textarea',
          {
            id: uId,
            ref: this.textArea,
            placeholder: placeholder,
            onChange: this.handleChange,
            className: 'materialize-textarea'
          },
          value
        ),
        label ? React.createElement(
          'label',
          null,
          label
        ) : null
      );
    }
  }]);
  return TextArea;
}(React.Component);

TextArea.propTypes = {
  placeholder: PropTypes.string,
  onChange: PropTypes.func,
  label: PropTypes.string,
  value: PropTypes.string
};

TextArea.defaultProps = {
  placeholder: null,
  onChange: null,
  label: null,
  value: null
};

var FileInput = function (_React$Component) {
  inherits(FileInput, _React$Component);

  function FileInput(props) {
    classCallCheck(this, FileInput);

    var _this = possibleConstructorReturn(this, (FileInput.__proto__ || Object.getPrototypeOf(FileInput)).call(this, props));

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;

      var value = e.target.files;
      _this.setState({ value: value });
      if (onChange) {
        onChange(value);
      }
    };

    _this.state = {
      uId: 'text-area-' + Math.random(),
      value: props.value
    };
    _this.textArea = React.createRef();
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(FileInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          placeholder = _props.placeholder,
          label = _props.label,
          multiple = _props.multiple;
      var _state = this.state,
          uId = _state.uId,
          value = _state.value;

      return React.createElement(
        'div',
        { className: 'file-field input-field' },
        React.createElement(
          'div',
          { className: 'btn' },
          React.createElement(
            'span',
            null,
            label
          ),
          multiple ? React.createElement('input', { type: 'file', onChange: this.handleChange, multiple: true }) : React.createElement('input', { type: 'file', onChange: this.handleChange })
        ),
        React.createElement(
          'div',
          { className: 'file-path-wrapper' },
          React.createElement('input', {
            id: uId,
            className: 'file-path validate',
            type: 'text',
            value: value,
            placeholder: placeholder
          })
        )
      );
    }
  }]);
  return FileInput;
}(React.Component);

FileInput.propTypes = {
  placeholder: PropTypes.string,
  onChange: PropTypes.func,
  label: PropTypes.string,
  value: PropTypes.string,
  multiple: PropTypes.bool
};

FileInput.defaultProps = {
  placeholder: null,
  onChange: null,
  label: 'File',
  value: null,
  multiple: false
};

var Range = function (_React$Component) {
  inherits(Range, _React$Component);

  function Range(props) {
    classCallCheck(this, Range);

    var _this = possibleConstructorReturn(this, (Range.__proto__ || Object.getPrototypeOf(Range)).call(this, props));

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;

      var value = e.target.value;
      _this.setState({ value: value, changed: true });
      if (onChange) {
        onChange(value);
      }
    };

    _this.state = {
      value: props.value,
      changed: false
    };
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(Range, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          min = _props.min,
          max = _props.max,
          label = _props.label;
      var _state = this.state,
          value = _state.value,
          changed = _state.changed;

      return React.createElement(
        'p',
        { className: 'range-field' },
        React.createElement(
          'div',
          { className: 'center' },
          React.createElement(
            'label',
            null,
            changed ? React.createElement(
              'label',
              null,
              value,
              '/',
              max
            ) : label
          )
        ),
        React.createElement('input', { type: 'range', value: value, min: min, max: max, onChange: this.handleChange })
      );
    }
  }]);
  return Range;
}(React.Component);

Range.propTypes = {
  min: PropTypes.number,
  max: PropTypes.number,
  value: PropTypes.string,
  label: PropTypes.string,
  onChange: PropTypes.func
};

Range.defaultProps = {
  min: 0,
  max: 100,
  value: null,
  label: 'Slide to Select',
  onChange: null
};

var CheckBox = function (_React$Component) {
  inherits(CheckBox, _React$Component);

  function CheckBox(props) {
    classCallCheck(this, CheckBox);

    var _this = possibleConstructorReturn(this, (CheckBox.__proto__ || Object.getPrototypeOf(CheckBox)).call(this, props));

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;
      var value = _this.state.value;

      _this.setState(function (prevState) {
        return { value: !prevState.value };
      });
      if (onChange) {
        onChange(!value);
      }
    };

    _this.state = {
      value: props.value
    };
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(CheckBox, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          filled = _props.filled,
          disabled = _props.disabled;
      var value = this.state.value;

      return React.createElement(
        'p',
        null,
        React.createElement(
          'label',
          null,
          React.createElement('input', { type: 'checkbox', onChange: this.handleChange, className: filled ? 'filled-in' : '', disabled: disabled ? 'disabled' : '', checked: value }),
          React.createElement(
            'span',
            null,
            label
          )
        )
      );
    }
  }]);
  return CheckBox;
}(React.Component);

CheckBox.propTypes = {
  filled: PropTypes.bool,
  disabled: PropTypes.bool,
  value: PropTypes.bool,
  label: PropTypes.string,
  onChange: PropTypes.func
};

CheckBox.defaultProps = {
  filled: false,
  disabled: false,
  value: false,
  label: '',
  onChange: null
};

var DatePicker = function (_React$Component) {
  inherits(DatePicker, _React$Component);

  function DatePicker(props) {
    classCallCheck(this, DatePicker);

    var _this = possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this, props));

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;
      var value = _this.state.value;

      _this.setState(function (prevState) {
        return { value: !prevState.value };
      });
      if (onChange) {
        onChange(!value);
      }
    };

    _this.state = {
      value: props.value
    };
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(DatePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          filledIn = _props.filledIn,
          disabled = _props.disabled;
      var value = this.state.value;

      return React.createElement(
        'p',
        null,
        React.createElement(
          'label',
          null,
          React.createElement('input', { type: 'checkbox', onChange: this.handleChange, className: filledIn ? 'filled-in' : '', disabled: disabled ? 'disabled' : '', checked: value }),
          React.createElement(
            'span',
            null,
            label
          )
        )
      );
    }
  }]);
  return DatePicker;
}(React.Component);

DatePicker.propTypes = {
  filledIn: PropTypes.bool,
  disabled: PropTypes.bool,
  value: PropTypes.bool,
  label: PropTypes.string,
  onChange: PropTypes.func
};

DatePicker.defaultProps = {
  filledIn: false,
  disabled: false,
  value: false,
  label: '',
  onChange: null
};

var TimePicker = function (_React$Component) {
  inherits(TimePicker, _React$Component);

  function TimePicker(props) {
    classCallCheck(this, TimePicker);

    var _this = possibleConstructorReturn(this, (TimePicker.__proto__ || Object.getPrototypeOf(TimePicker)).call(this, props));

    _this.handleChange = function (e) {
      var onChange = _this.props.onChange;
      var value = _this.state.value;

      _this.setState(function (prevState) {
        return { value: !prevState.value };
      });
      if (onChange) {
        onChange(!value);
      }
    };

    _this.state = {
      value: props.value
    };
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(TimePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          filledIn = _props.filledIn,
          disabled = _props.disabled;
      var value = this.state.value;

      return React.createElement(
        'p',
        null,
        React.createElement(
          'label',
          null,
          React.createElement('input', { type: 'checkbox', onChange: this.handleChange, className: filledIn ? 'filled-in' : '', disabled: disabled ? 'disabled' : '', checked: value }),
          React.createElement(
            'span',
            null,
            label
          )
        )
      );
    }
  }]);
  return TimePicker;
}(React.Component);

TimePicker.propTypes = {
  filledIn: PropTypes.bool,
  disabled: PropTypes.bool,
  value: PropTypes.bool,
  label: PropTypes.string,
  onChange: PropTypes.func
};

TimePicker.defaultProps = {
  filledIn: false,
  disabled: false,
  value: false,
  label: '',
  onChange: null
};

var RadioButton = function (_React$Component) {
  inherits(RadioButton, _React$Component);

  function RadioButton(props) {
    classCallCheck(this, RadioButton);

    var _this = possibleConstructorReturn(this, (RadioButton.__proto__ || Object.getPrototypeOf(RadioButton)).call(this, props));

    _this.handleChange = function (e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          group = _this$props.group,
          label = _this$props.label;

      if (onChange) {
        onChange({ label: label, group: group });
      }
    };

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(RadioButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          group = _props.group,
          label = _props.label,
          gap = _props.gap,
          disabled = _props.disabled;

      return React.createElement(
        'p',
        null,
        React.createElement(
          'label',
          null,
          React.createElement('input', { type: 'radio', name: group, onChange: this.handleChange, className: gap ? 'with-gap' : '', disabled: disabled ? 'disabled' : '' }),
          React.createElement(
            'span',
            null,
            label
          )
        )
      );
    }
  }]);
  return RadioButton;
}(React.Component);

RadioButton.propTypes = {
  group: PropTypes.string,
  gap: PropTypes.bool,
  disabled: PropTypes.bool,
  label: PropTypes.string,
  onChange: PropTypes.func
};

RadioButton.defaultProps = {
  group: null,
  gap: false,
  disabled: false,
  label: '',
  onChange: null
};

var Switch = function (_React$Component) {
  inherits(Switch, _React$Component);

  function Switch(props) {
    classCallCheck(this, Switch);

    var _this = possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this, props));

    _this.handleChange = function (e) {
      var value = _this.state.value;

      _this.setState(function (prevState) {
        return { value: !prevState.value };
      });
      var onChange = _this.props.onChange;

      if (onChange) {
        onChange(!value);
      }
    };

    _this.state = {
      value: props.value
    };
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  createClass(Switch, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          left = _props.left,
          right = _props.right,
          disabled = _props.disabled;
      var value = this.state.value;

      return React.createElement(
        'div',
        { className: 'switch' },
        React.createElement(
          'label',
          null,
          left,
          React.createElement('input', { type: 'checkbox', onChange: this.handleChange, checked: value, disabled: disabled ? 'disabled' : '' }),
          React.createElement('span', { className: 'lever' }),
          right
        )
      );
    }
  }]);
  return Switch;
}(React.Component);

Switch.propTypes = {
  value: PropTypes.bool,
  left: PropTypes.string,
  right: PropTypes.string,
  disabled: PropTypes.bool,
  onChange: PropTypes.func
};

Switch.defaultProps = {
  value: false,
  left: null,
  right: null,
  disabled: false,
  onChange: null
};

export { TextInput, Select, Chips, TextArea, FileInput, Range, CheckBox, DatePicker, TimePicker, RadioButton, Switch };
//# sourceMappingURL=index.es.js.map
